image: python:latest

stages:
  - build
  - test
  - plan-infra # To run the terraform Plan
  - apply-infra
  - deploy # apply the terraform plan and deploy in lambda
  - destroy

build1:
  when: manual
  stage: build
  script:
    - echo "This is Build stage, Creating a zip of code"
    - chmod 777 scripts/zipSrcFolder.py
    - python scripts/zipSrcFolder.py
    - echo "Created the Zip successfuly"
  artifacts:
    paths:
      - build
#
#build2:
#  when: manual
#  image: python:2
#  stage: build
#  script:
#    - echo "Building Test Env"
#    - mkdir build
#    - touch build/info2.txt
#  artifacts:
#    paths:
#      - build

#test:
#  when: manual
#  stage: test
#  script:
#    - echo "testing"
#    - test -f "build/info1.txt"
#    - test -f "build/info2.txt"

dev-plan:
  image:
    name: hashicorp/terraform:light
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  stage: plan-infra
  dependencies:
    - build1
  when: manual
  script:
    - rm -rf .terraform
    - terraform --version
    - terraform init
    - terraform plan

dev-apply:
  image:
    name: hashicorp/terraform:light
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  stage: apply-infra
  when: manual
  script:
    - terraform init
    - if [ "$CI_COMMIT_TAG" ]; then FILE_NAME="${APP_NAME}_${CI_COMMIT_TAG}.zip"; else FILE_NAME="${APP_NAME}_${CI_COMMIT_SHA}.zip"; fi
    - echo "File name is ${FILE_NAME}"
    - export TF_VAR_zip_file_name="$FILE_NAME"
    - export TF_VAR_region_name="$AWS_DEFAULT_REGION"
    - terraform apply -input=false -auto-approve

dev-deploy:
  stage: deploy
  when: manual
  script:
    - echo "in progress!!"


dev-destroy:
  image:
    name: hashicorp/terraform:light
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  stage: destroy
  when: manual
  script:
    - terraform init
    - terraform destroy -input=false -auto-approve